// Copyright (c) 2024 Codemongous LLC. All Rights Reserved.

#pragma once

#include "ISCW_FSubobjectData.h"
#include <memory>
#include <string>

using std::shared_ptr;
using std::wstring;

namespace Sourcify
{	
	class ISCW_FSubobjectDataHandle
	{
	public:
		virtual ~ISCW_FSubobjectDataHandle() = default;
		
		virtual ISCW_FSubobjectDataPtr GetData() const = 0;

		virtual shared_ptr<ISCW_FSubobjectDataHandle> ToFSubobjectDataHandlePtr() = 0;
		virtual shared_ptr<const ISCW_FSubobjectDataHandle> ToFSubobjectDataHandlePtr() const = 0;
	};

	using ISCW_FSubobjectDataHandleConstPtr = shared_ptr<const ISCW_FSubobjectDataHandle>;
	using ISCW_FSubobjectDataHandlePtr = shared_ptr<ISCW_FSubobjectDataHandle>;
} // namespace Sourcify